hdu 2639 Bone Collector II(01背包 第K大价值)

Bone Collector II

Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3355    Accepted Submission(s):
1726

Problem Description

The title of this problem is familiar,isn‘t it?yeah,if
you had took part in the "Rookie Cup" competition,you must have seem this
title.If you haven‘t seen it before,it doesn‘t matter,I will give you a
link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today
we are not desiring the maximum value of bones,but the K-th maximum value of the
bones.NOTICE that,we considerate two ways that get the same value of bones are
the same.That means,it will be a strictly decreasing sequence from the 1st
maximum , 2nd maximum .. to the K-th maximum.

If the total number of
different values is less than K,just ouput 0.

Input

The first line contain a integer T , the number of
cases.
Followed by T cases , each case three lines , the first line contain
two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the
number of bones and the volume of his bag and the K we need. And the second line
contain N integers representing the value of each bone. The third line contain N
integers representing the volume of each bone.

Output

One integer per line representing the K-th maximum of
the total value (this number will be less than 231).

Sample Input

3

5 10 2

1 2 3 4 5

5 4 3 2 1

5 10 12

1 2 3 4 5

5 4 3 2 1

5 10 16

1 2 3 4 5

5 4 3 2 1

Sample Output

12

2

0

Author

teddy

Source

百万秦关终属楚

Recommend

teddy   |   We have carefully selected several similar
problems for you:  2159 1114 3033 1561 1712

还是01背包问题,不过我是第一次写这种类型的题,参考了别人的代码和思想,差不多是一道模板第k大价值题,值得一做。

更新的时候有两个数组A、B,A记录选择第i个物品的从大到小排列,B记录不选择的从大到小排列,然后合并AB,选出AB里面前k个最大的。合并到dp中。。。

题意:第一行三个数,第一个数为物体数量,第二个数总体积,第三个数第k优解。注意!接下来第二行是物体的价值,第三行是物体的体积。

求第k大优解的值是多少。

附上代码:

 1 #include <iostream>
 2 #include <cstdio>
 3 #include <cstring>
 4 using namespace std;
 5 int main()
 6 {
 7     int T,i,j,n,m,v,k,kk;
 8     int dp[1005][35],val[1005],vol[1005],A[35],B[35];
 9     scanf("%d",&T);
10     while(T--)
11     {
12         scanf("%d%d%d",&n,&v,&k);
13         for(i=0; i<n; i++)
14             scanf("%d",&val[i]);   //价值
15         for(i=0; i<n; i++)
16             scanf("%d",&vol[i]);    //体积
17         memset(dp,0,sizeof(dp));
18         int a,b,c;
19         for(i=0; i<n; i++)
20             for(j=v; j>=vol[i]; j--)
21             {
22                 for(kk=1; kk<=k; kk++)  //从最优的向后循环
23                 {
24                     A[kk]=dp[j-vol[i]][kk]+val[i];  //选中i物体
25                     B[kk]=dp[j][kk];         //不选i物体
26                 }
27                 A[kk]=-1;   //-1标记为结尾
28                 B[kk]=-1;
29                 a=b=c=1;
30                 while(c<=k&&(A[a]!=-1||B[b]!=-1))
31                 {
32                     if(A[a]>B[b])   //大的数排在前面
33                         dp[j][c]=A[a++];
34                     else
35                         dp[j][c]=B[b++];
36                     if(dp[j][c]!=dp[j][c-1]) //如果两数相同,则只记录一次
37                         c++;
38                 }
39             }
40         printf("%d\n",dp[v][k]);
41     }
42     return 0;
43 }
时间: 2024-10-03 04:43:26

hdu 2639 Bone Collector II(01背包 第K大价值)的相关文章

HDU 2639 Bone Collector II(01背包变型)

此题就是在01背包问题的基础上求所能获得的第K大的价值. 具体做法是加一维去推当前背包容量第0到K个价值,而这些价值则是由dp[j-w[ i ] ][0到k]和dp[ j ][0到k]得到的,其实就是2个数组合并之后排序,但是实际做法最好不要怎么做,因为你不知道总共有多少种,而我们最多只需要前K个大的就行了(因为可能2个数组加起来的组合数达不到K个),如果全部加起来数组开多大不清楚,所以可以选用归并排序中把左右2个有序数组合并成一个有序数组的方法来做,就是用2个变量去标记2个有序数组的头,然后比

HDU 2639 Bone Collector II(01背包变形【第K大最优解】)

Bone Collector II Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 4739    Accepted Submission(s): 2470 Problem Description The title of this problem is familiar,isn't it?yeah,if you had took pa

hdu 2639 Bone Collector II 01背包问题 求第K大最优值。。

Bone Collector II Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2665    Accepted Submission(s): 1392 Problem Description The title of this problem is familiar,isn't it?yeah,if you had took pa

HDU 2639 Bone Collector II (DP 第k优解)

题意:输入t,t组测试样例,每组样例输入 n, v, k. 接着输入n个物品的价值,再输入n个物品的体积.求k优解. 分析:dp[n][v][k]表示n个物品,在体积不超过v的情况,第k大的值是多少.dp[i][v][k]与dp[i-1][v][k]与dp[i-1][v-volume[i]]+value[i]有关. #include <iostream> #include <cstdio> #include <cstring> #include <algorith

HDU 2639 Bone Collector II

Bone Collector II Time Limit: 2000ms Memory Limit: 32768KB This problem will be judged on HDU. Original ID: 263964-bit integer IO format: %I64d      Java class name: Main The title of this problem is familiar,isn't it?yeah,if you had took part in the

hdu 2602 Bone Collector 【01背包模板】

Bone Collector Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 40404    Accepted Submission(s): 16786 Problem Description Many years ago , in Teddy's hometown there was a man who was called "Bo

HDU2639Bone Collector II[01背包第k优值]

Bone Collector II Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 4229    Accepted Submission(s): 2205 Problem Description The title of this problem is familiar,isn't it?yeah,if you had took par

hdu 2602 Bone Collector(01背包)

Bone Collector Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 42179    Accepted Submission(s): 17543 Problem Description Many years ago , in Teddy’s hometown there was a man who was called “Bon

hdu 2602 Bone Collector(01背包)模板

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2602 Bone Collector Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 54132    Accepted Submission(s): 22670 Problem Description Many years ago , in